#@output ImagePlus WHITE_ESTIMATE
"""This script is supposed to be launched from fiji's jython interpreter
"""

#from ij import IJ  # pylint: disable=import-error

#WHITE_ESTIMATE = IJ.openImage('/Users/graffy/ownCloud/ipr/lipase/lipase.git/white_estimate.tiff')

# # note: fiji's jython doesn't support encoding keyword

# https://imagej.net/Scripting_Headless
# String lipase_src_root_path

# String(label="Please enter your name",description="Name field") name
# OUTPUT String greeting
import sys
print('python version %s' % sys.version)  # prints python version

from lipase.settings import UserSettings

# it is necassary to add lipase's root path to the path if run from fiji as script otherwise jython fails to find lipase's modules such as catalog
# sys.path.append(lipase_src_root_path)  # pylint: disable=undefined-variable

# from lipase import Lipase, ImageLogger
from lipase.preprocessing import test_preprocessing  # noqa: E402 pylint: disable=import-error,wrong-import-position
from lipase.imageengine import IImageEngine
from lipase.imagej.ijimageengine import IJImageEngine
from lipase.preprocessing import WhiteEstimator
from lipase.catalog import ImageCatalog

def run_script():
    user_settings = UserSettings()
    IImageEngine.set_instance(IJImageEngine())
    catalog = ImageCatalog(user_settings.raw_images_root_path)
    sequence = catalog.sequences['res_soleil2018/GGH/GGH_2018_cin2_phiG_I_327_vis_-40_1/Pos2']
    white_estimator = WhiteEstimator(open_size=75, close_size=75, average_size=75)
    white_estimate = white_estimator.estimate_white([sequence], ['DM300_327-353_fluo'])
    print(type(white_estimate))
    global WHITE_ESTIMATE
    WHITE_ESTIMATE = white_estimate.ij_image

# note : when launched from fiji, __name__ doesn't have the value "__main__", as when launched from python
run_script()
